#region usings
using System;
using System.ComponentModel.Composition;
using System.Linq;

using VVVV.PluginInterfaces.V2;


using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "Rot13", Category = "String")]
	#endregion PluginInfo
	public class StringRot13Node : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultString = "Hello")]
		public IDiffSpread<String> FInput;

		[Output("Output")]
		public ISpread<String> FOutput;

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			if (FInput.IsChanged)
			{
				FOutput.SliceCount = SpreadMax;
				for (int i = 0; i < SpreadMax; i++)
				{
					FOutput[i] = ROT13 (FInput[i]);
				}
			}
			
		}
		
		static string ROT13(string input)
		{
    		return !string.IsNullOrEmpty(input) ? new string (input.ToCharArray().Select(s =>  { return (char)(( s >= 97 && s <= 122 ) ? ( (s + 13 > 122 ) ? s - 13 : s + 13) : ( s >= 65 && s <= 90 ? (s + 13 > 90 ? s - 13 : s + 13) : s )); }).ToArray() ) : input;            
		}
	}
}
